CompositeView (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text, class: CompositeView
Keywords: javax.swing.text.CompositeView class

# Class CompositeView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView

All Implemented Interfaces:
  `SwingConstants`

Direct Known Subclasses:
  `BoxView`

public abstract class CompositeView extends View
`CompositeView` is an abstract `View` implementation which manages one or more child views. (Note that `CompositeView` is intended for managing relatively small numbers of child views.) `CompositeView` is intended to be used as a starting point for `View` implementations, such as `BoxView`, that will contain child `View`s. Subclasses that wish to manage the collection of child `View`s should use the `replace(int, int, View[])` method. As `View` invokes `replace` during `DocumentListener` notification, you normally won't need to directly invoke `replace`.

While `CompositeView` does not impose a layout policy on its child `View`s, it does allow for insetting the child `View`s it will contain. The insets can be set by either `setInsets(short, short, short, short)` or `setParagraphInsets(AttributeSet)`.

In addition to the abstract methods of `View`, subclasses of `CompositeView` will need to override:

- `isBefore(int, int, Rectangle)` - Used to test if a given `View` location is before the visual space of the `CompositeView`.
- `isAfter(int, int, Rectangle)` - Used to test if a given `View` location is after the visual space of the `CompositeView`.
- `getViewAtPoint(int, int, Rectangle)` - Returns the view at a given visual location.
- `childAllocation(int, Rectangle)` - Returns the bounds of a particular child `View`. `getChildAllocation` will invoke `childAllocation` after offsetting the bounds by the `Inset`s of the `CompositeView`.

- ## Field Summary

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CompositeView(Element elem)`
  Constructs a `CompositeView` for the given element.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract void`
  `childAllocation(int index, Rectangle a)`
  Returns the allocation for a given child.
  `protected boolean`
  `flipEastAndWestAtEnds(int position, Position.Bias bias)`
  Determines in which direction the next view lays.
  `protected short`
  `getBottomInset()`
  Gets the bottom inset.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view to render into.
  `protected Rectangle`
  `getInsideAllocation(Shape a)`
  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
  `protected short`
  `getLeftInset()`
  Gets the left inset.
  `protected int`
  `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `protected int`
  `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the north or south direction.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location that one might place a caret.
  `protected short`
  `getRightInset()`
  Gets the right inset.
  `protected short`
  `getTopInset()`
  Gets the top inset.
  `View`
  `getView(int n)`
  Returns the n-th view in this container.
  `protected abstract View`
  `getViewAtPoint(int x, int y, Rectangle alloc)`
  Fetches the child view at the given coordinates.
  `protected View`
  `getViewAtPosition(int pos, Rectangle a)`
  Fetches the child view that represents the given position in the model.
  `int`
  `getViewCount()`
  Returns the number of child views of this view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `protected int`
  `getViewIndexAtPosition(int pos)`
  Fetches the child view index representing the given position in the model.
  `protected abstract boolean`
  `isAfter(int x, int y, Rectangle alloc)`
  Tests whether a point lies after the rectangle range.
  `protected abstract boolean`
  `isBefore(int x, int y, Rectangle alloc)`
  Tests whether a point lies before the rectangle range.
  `protected void`
  `loadChildren(ViewFactory f)`
  Loads all of the children to initialize the view.
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `void`
  `replace(int offset, int length, View[] views)`
  Replaces child views.
  `protected void`
  `setInsets(short top, short left, short bottom, short right)`
  Sets the insets for the view.
  `protected void`
  `setParagraphInsets(AttributeSet attr)`
  Sets the insets from the paragraph attributes specified in the given attributes.
  `void`
  `setParent(View parent)`
  Sets the parent of the view.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class View

  `append, breakView, changedUpdate, createFragment, forwardUpdate, forwardUpdateToView, getAlignment, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getMaximumSpan, getMinimumSpan, getParent, getPreferredSpan, getResizeWeight, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, insertUpdate, isVisible, modelToView, paint, preferenceChanged, remove, removeAll, removeUpdate, setSize, updateChildren, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `void`
  `changedUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `View`
  `getParent()`
  Returns the parent of the view.
  `abstract float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `int`
  `getResizeWeight(int axis)`
  Determines the resizability of the view along the given axis.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `void`
  `insertUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `abstract void`
  `paint(Graphics g, Shape allocation)`
  Renders using the given rendering surface and area on that surface.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  Child views can call this on the parent to indicate that the preference has changed and should be reconsidered for layout.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `void`
  `removeUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CompositeView

    public CompositeView(Element elem)
    Constructs a `CompositeView` for the given element.
    Parameters:
      `elem` - the element this view is responsible for

- ## Method Details

  - ### loadChildren

    protected void loadChildren(ViewFactory f)
    Loads all of the children to initialize the view. This is called by the `setParent(View)` method. Subclasses can reimplement this to initialize their child views in a different manner. The default implementation creates a child view for each child element.
    Parameters:
      `f` - the view factory
    See Also:
      - `setParent(View)`

  - ### setParent

    public void setParent(View parent)
    Sets the parent of the view. This is reimplemented to provide the superclass behavior as well as calling the `loadChildren` method if this view does not already have children. The children should not be loaded in the constructor because the act of setting the parent may cause them to try to search up the hierarchy (to get the hosting `Container` for example). If this view has children (the view is being moved from one place in the view hierarchy to another), the `loadChildren` method will not be called.
    Overrides:
      `setParent` in class `View`
    Parameters:
      `parent` - the parent of the view, `null` if none

  - ### getViewCount

    public int getViewCount()
    Returns the number of child views of this view.
    Overrides:
      `getViewCount` in class `View`
    Returns:
      the number of views >= 0
    See Also:
      - `getView(int)`

  - ### getView

    public View getView(int n)
    Returns the n-th view in this container.
    Overrides:
      `getView` in class `View`
    Parameters:
      `n` - the number of the desired view, >= 0 && < getViewCount()
    Returns:
      the view at index `n`

  - ### replace

    public void replace(int offset, int length, View[] views)
    Replaces child views. If there are no views to remove this acts as an insert. If there are no views to add this acts as a remove. Views being removed will have the parent set to `null`, and the internal reference to them removed so that they may be garbage collected.
    Overrides:
      `replace` in class `View`
    Parameters:
      `offset` - the starting index into the child views to insert the new views; >= 0 and <= getViewCount
      `length` - the number of existing child views to remove; this should be a value >= 0 and <= (getViewCount() - offset)
      `views` - the child views to add; this value can be `null` to indicate no children are being added (useful to remove)

  - ### getChildAllocation

    public Shape getChildAllocation(int index, Shape a)
    Fetches the allocation for the given child view to render into. This enables finding out where various views are located.
    Overrides:
      `getChildAllocation` in class `View`
    Parameters:
      `index` - the index of the child, >= 0 && < getViewCount()
      `a` - the allocation to this view
    Returns:
      the allocation to the child

  - ### modelToView

    public Shape modelToView(int pos, Shape a, Position.Bias b) throws BadLocationException
    Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
    Specified by:
      `modelToView` in class `View`
    Parameters:
      `pos` - the position to convert >= 0
      `a` - the allocated region to render into
      `b` - a bias value of either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      the bounding box of the given position
    Throws:
      `BadLocationException` - if the given position does not represent a valid location in the associated document
    See Also:
      - `View.modelToView(int, Shape, Position.Bias)`

  - ### modelToView

    public Shape modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a) throws BadLocationException
    Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
    Overrides:
      `modelToView` in class `View`
    Parameters:
      `p0` - the position to convert >= 0
      `b0` - the bias toward the previous character or the next character represented by p0, in case the position is a boundary of two views; either `Position.Bias.Forward` or `Position.Bias.Backward`
      `p1` - the position to convert >= 0
      `b1` - the bias toward the previous character or the next character represented by p1, in case the position is a boundary of two views
      `a` - the allocated region to render into
    Returns:
      the bounding box of the given position is returned
    Throws:
      `BadLocationException` - if the given position does not represent a valid location in the associated document
      `IllegalArgumentException` - for an invalid bias argument
    See Also:
      - `View.viewToModel(float, float, Shape, Position.Bias[])`

  - ### viewToModel

    public int viewToModel(float x, float y, Shape a, Position.Bias[] bias)
    Provides a mapping from the view coordinate space to the logical coordinate space of the model.
    Specified by:
      `viewToModel` in class `View`
    Parameters:
      `x` - x coordinate of the view location to convert >= 0
      `y` - y coordinate of the view location to convert >= 0
      `a` - the allocated region to render into
      `bias` - either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      the location within the model that best represents the given point in the view >= 0
    See Also:
      - `View.viewToModel(float, float, Shape, Position.Bias[])`

  - ### getNextVisualPositionFrom

    public int getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet) throws BadLocationException
    Provides a way to determine the next visually represented model location that one might place a caret. Some views may not be visible, they might not be in the same order found in the model, or they just might not allow access to some of the locations in the model. This is a convenience method for `getNextNorthSouthVisualPositionFrom(int, Position.Bias, Shape, int, Position.Bias[])` and `getNextEastWestVisualPositionFrom(int, Position.Bias, Shape, int, Position.Bias[])`. This method enables specifying a position to convert within the range of >=0. If the value is -1, a position will be calculated automatically. If the value < -1, the `BadLocationException` will be thrown.
    Overrides:
      `getNextVisualPositionFrom` in class `View`
    Parameters:
      `pos` - the position to convert
      `b` - a bias value of either `Position.Bias.Forward` or `Position.Bias.Backward`
      `a` - the allocated region to render into
      `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard; this may be one of the following:
      - `SwingConstants.WEST`
      - `SwingConstants.EAST`
      - `SwingConstants.NORTH`
      - `SwingConstants.SOUTH`
      `biasRet` - an array containing the bias that was checked
    Returns:
      the location within the model that best represents the next location visual position
    Throws:
      `BadLocationException` - the given position is not a valid position within the document
      `IllegalArgumentException` - if `direction` is invalid

  - ### getViewIndex

    public int getViewIndex(int pos, Position.Bias b)
    Returns the child view index representing the given position in the model. This is implemented to call the `getViewIndexByPosition` method for backward compatibility.
    Overrides:
      `getViewIndex` in class `View`
    Parameters:
      `pos` - the position >= 0
      `b` - the bias
    Returns:
      index of the view representing the given position, or -1 if no view represents that position
    Since:
      1.3

  - ### isBefore

    protected abstract boolean isBefore(int x, int y, Rectangle alloc)
    Tests whether a point lies before the rectangle range.
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `alloc` - the rectangle
    Returns:
      true if the point is before the specified range

  - ### isAfter

    protected abstract boolean isAfter(int x, int y, Rectangle alloc)
    Tests whether a point lies after the rectangle range.
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `alloc` - the rectangle
    Returns:
      true if the point is after the specified range

  - ### getViewAtPoint

    protected abstract View getViewAtPoint(int x, int y, Rectangle alloc)
    Fetches the child view at the given coordinates.
    Parameters:
      `x` - the X coordinate >= 0
      `y` - the Y coordinate >= 0
      `alloc` - the parent's allocation on entry, which should be changed to the child's allocation on exit
    Returns:
      the child view

  - ### childAllocation

    protected abstract void childAllocation(int index, Rectangle a)
    Returns the allocation for a given child.
    Parameters:
      `index` - the index of the child, >= 0 && < getViewCount()
      `a` - the allocation to the interior of the box on entry, and the allocation of the child view at the index on exit.

  - ### getViewAtPosition

    protected View getViewAtPosition(int pos, Rectangle a)
    Fetches the child view that represents the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
    Parameters:
      `pos` - the position >= 0
      `a` - the allocation to the interior of the box on entry, and the allocation of the view containing the position on exit
    Returns:
      the view representing the given position, or `null` if there isn't one

  - ### getViewIndexAtPosition

    protected int getViewIndexAtPosition(int pos)
    Fetches the child view index representing the given position in the model. This is implemented to fetch the view in the case where there is a child view for each child element.
    Parameters:
      `pos` - the position >= 0
    Returns:
      index of the view representing the given position, or -1 if no view represents that position

  - ### getInsideAllocation

    protected Rectangle getInsideAllocation(Shape a)
    Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed. It is expected that the returned value would be further mutated to represent an allocation to a child view. This is implemented to reuse an instance variable so it avoids creating excessive Rectangles. Typically the result of calling this method would be fed to the `childAllocation` method.
    Parameters:
      `a` - the allocation given to the view
    Returns:
      the allocation that represents the inside of the view after the margins have all been removed; if the given allocation was `null`, the return value is `null`

  - ### setParagraphInsets

    protected void setParagraphInsets(AttributeSet attr)
    Sets the insets from the paragraph attributes specified in the given attributes.
    Parameters:
      `attr` - the attributes

  - ### setInsets

    protected void setInsets(short top, short left, short bottom, short right)
    Sets the insets for the view.
    Parameters:
      `top` - the top inset >= 0
      `left` - the left inset >= 0
      `bottom` - the bottom inset >= 0
      `right` - the right inset >= 0

  - ### getLeftInset

    protected short getLeftInset()
    Gets the left inset.
    Returns:
      the inset >= 0

  - ### getRightInset

    protected short getRightInset()
    Gets the right inset.
    Returns:
      the inset >= 0

  - ### getTopInset

    protected short getTopInset()
    Gets the top inset.
    Returns:
      the inset >= 0

  - ### getBottomInset

    protected short getBottomInset()
    Gets the bottom inset.
    Returns:
      the inset >= 0

  - ### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet) throws BadLocationException
    Returns the next visual position for the cursor, in either the north or south direction.
    Parameters:
      `pos` - the position to convert >= 0
      `b` - a bias value of either `Position.Bias.Forward` or `Position.Bias.Backward`
      `a` - the allocated region to render into
      `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard; this may be one of the following:
      - `SwingConstants.NORTH`
      - `SwingConstants.SOUTH`
      `biasRet` - an array containing the bias that was checked
    Returns:
      the location within the model that best represents the next north or south location
    Throws:
      `BadLocationException` - for a bad location within a document model
      `IllegalArgumentException` - if `direction` is invalid
    See Also:
      - `getNextVisualPositionFrom(int, Position.Bias, Shape, int, Position.Bias[])`

  - ### getNextEastWestVisualPositionFrom

    protected int getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet) throws BadLocationException
    Returns the next visual position for the cursor, in either the east or west direction.
    Parameters:
      `pos` - the position to convert >= 0
      `b` - a bias value of either `Position.Bias.Forward` or `Position.Bias.Backward`
      `a` - the allocated region to render into
      `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard; this may be one of the following:
      - `SwingConstants.WEST`
      - `SwingConstants.EAST`
      `biasRet` - an array containing the bias that was checked
    Returns:
      the location within the model that best represents the next west or east location
    Throws:
      `BadLocationException` - for a bad location within a document model
      `IllegalArgumentException` - if `direction` is invalid
    See Also:
      - `getNextVisualPositionFrom(int, Position.Bias, Shape, int, Position.Bias[])`

  - ### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position, Position.Bias bias)
    Determines in which direction the next view lays. Consider the `View` at index n. Typically the `View`s are laid out from left to right, so that the `View` to the EAST will be at index n + 1, and the `View` to the WEST will be at index n - 1. In certain situations, such as with bidirectional text, it is possible that the `View` to EAST is not at index n + 1, but rather at index n - 1, or that the `View` to the WEST is not at index n - 1, but index n + 1. In this case this method would return true, indicating the `View`s are laid out in descending order.

    This unconditionally returns false, subclasses should override this method if there is the possibility for laying `View`s in descending order.

    Parameters:
      `position` - position into the model
      `bias` - either `Position.Bias.Forward` or `Position.Bias.Backward`
    Returns:
      false